*
* IShellLink Interface
* https://msdn.microsoft.com/en-us/library/windows/desktop/bb776891%28v=vs.85%29.aspx
*
* ShellLinkObject object
* https://msdn.microsoft.com/de-de/library/windows/desktop/bb774004%28v=vs.85%29.aspx
*

***************************************
*
* aHotKey[1] -> ASCI Number e.g. ASC("Z")
* aHotKey[2] -> CTRL+ALT -> 2+4
*
* (1)   SHIFT key
* (2)   CTRL key
* (4)   ALT key
* (8)   Extended key
***************************************

***************************************
* Icon Index zero-based
*
* {"shell32.dll", 3 }
* {cAppPath+"Strait.ico", 0 }
* { AppName(.T.), 1 }                  // { FullpathName, Index }
***************************************

PROCEDURE MAIN
LOCAL cLinkTarget := Getenv("windir")+"\Notepad.exe"            // EXE, BAT
LOCAL cLinkFile   := Getenv("USERPROFILE")+"\Desktop\Test1.LNK" // where create
LOCAL cWorkingDir := GetStartUpFolder() + "\"                   // working Dir
LOCAL cCmdArgs    := "README.TXT"                               // Parameter
LOCAL cDescr      := "Test Create Link with Icon and Hotkey"    // Description
LOCAL aIcon       := {"shell32.dll", 3 }
LOCAL aHotKey     := {ASC("Z"),2+4}
LOCAL nPosi,cPara,cFull,cPath,cName

   IF FILE(cLinkFile)
      FErase(cLinkFile)
   ENDIF

* ------------- CreateLink ------------- *

   DXE_CreateLink(cLinkTarget,cLinkFile,cWorkingDir,cCmdArgs,cDescr,;
                  aHotKey,aIcon)

* ------------- ResolveLink ------------- *

   cFull := DXE_ResolveLink(cLinkFile)

   // CHR(0) as Delimiter
   nPosi := AT(CHR(0),cFull)
   IF nPosi > 0
      // you do not see Parameter after CHR(0) in MsgBox()
      // msgbox(cFull,"using CHR(0)")
      cPara := SUBSTR(cFull,nPosi+1)
      cFull := SUBSTR(cFull,1,nPosi-1)
*      MsgInfo(cFull+" "+cPara)
      RUN (cFull+" "+cPara)
   ENDIF

RETURN

*
* eof
*