#include "common.ch"
#include "fileio.ch"

FUNCTION DXE_CreateLink( cLinkTarget, cLinkFile, cWorkingDir, cCmdArgs, cDescr, aHotKey, aIcon )
LOCAL lSuccess    := .F.
LOCAL nPosi       := 0
LOCAL cPath       := ""
LOCAL cFile       := ""
LOCAL cName       := ""
LOCAL oShell
LOCAL oFolder
LOCAL oFolderItem
LOCAL oShellLink
LOCAL nHandle
LOCAL i, iMax
LOCAL nLoByte
LOCAL nHiByte

   DEFAULT cWorkingDir TO ""
   DEFAULT cCmdArgs TO ""
   DEFAULT cDescr TO ""
   DEFAULT aHotKey TO {}
   DEFAULT aIcon TO {}

   IF !EMPTY( cLinkTarget )
      nPosi := RAT( "\", cLinkFile )
      IF nPosi > 0
         cPath := SUBSTR( cLinkFile, 1, nPosi - 1 )
         cFile := SUBSTR( cLinkFile, nPosi + 1 )
      ENDIF

      // create empty file with 0 (zero) byte
      nHandle := FCREATE( cLinkFile, FC_NORMAL )
      FCLOSE( nHandle )
   ENDIF

   IF !EMPTY( cPath ) .AND. !EMPTY( cFile ) .AND. FILE( cLinkFile )
      oShell := CreateObject( "shell.application" )
      oFolder := oShell:NameSpace( cPath )
      oFolderItem := oFolder:ParseName( cFile )

      IF !EMPTY( oFolderItem )
         oShellLink := oFolderItem:GetLink
         IF !EMPTY( oShellLink )
            // set Property
            oShellLink:Path := cLinkTarget
            oShellLink:WorkingDirectory := cWorkingDir
            oShellLink:Arguments := cCmdArgs
            oShellLink:Description := cDescr
            oShellLink:ShowCommand := 1

            // Shortcut Hotkey
            IF !EMPTY( aHotKey ) .AND. VALTYPE( aHotKey ) = "A"
               IF LEN( aHotKey ) = 2
                  nLoByte := aHotKey[ 1 ]
                  nHiByte := aHotKey[ 2 ]
                  //  oShellLink:Hotkey := MakeWord( nLoByte , nHiByte )
               ENDIF
            ENDIF

            // Icon need Method
            IF !EMPTY( aIcon ) .AND. VALTYPE( aIcon ) = "A"
               IF LEN( aIcon ) = 2
                  oShellLink:SetIconLocation( aIcon[ 1 ], aIcon[ 2 ] )
               ENDIF
            ENDIF

            // now save
            oShellLink:Save( cLinkFile )

            lSuccess := .T.
         ENDIF
      ENDIF

      //       IF !EMPTY(oShellLink)
      //          oShellLink  :destroy()
      //       ENDIF
      //       IF !EMPTY(oFolderItem)
      //          oFolderItem :destroy()
      //       ENDIF
      //       IF !EMPTY(oFolder)
      //          oFolder     :destroy()
      //       ENDIF
      //        IF !EMPTY(oShell)
      //           oShell      :destroy()
      //        ENDIF

      oShellLink := NIL
      oFolderItem := NIL
      oFolder := NIL
      oShell := NIL

   ENDIF

RETURN lSuccess
